
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>深入理解JavaScript系列（1）：编写高质量JavaScript代码的基本要点(转) / 憋错料</title>

    <meta name="description" content="深入理解JavaScript系列（1）：编写高质量JavaScript代码的基本要点(转) 才华横溢的Stoyan Stefanov,在他写的由O’Reilly初版的新书&lt;JavaScript Patterns&gt;(JavaScript模式)中,我想要是为我们的读者贡献其摘要,那会是件很美妙的事情.具体一点就是编写高质量JavaScript的一些要素,例如避免全局变量,使用单变量声明,在循环中预缓存length(长度),遵循代码阅读,以及更多. 此摘要也包括一些与代码不太相关的习惯,但对整体代码的创建息息相关,包括撰写API文档.执行同行评审以及运行JSLint.这些习惯和最 ...">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/bootstrap.css" rel="stylesheet">
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?1438792cdde0845a4a8fe9d36e3569f8";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>

 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="//pic.ikafan.com/staticx/biecuoliao/1/assets/logo.png?2" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/category/编程语言/">编程语言</a></li>
            <li><a href="/category/Web开发/">Web开发</a></li>
            <li><a href="/category/移动开发/">移动开发</a></li>
            <li><a href="/category/数据库/">数据库</a></li>
            <li><a href="/category/系统相关/">系统相关</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    


<div id="main" class="col-md-8">


<h1 class="mtitle">深入理解JavaScript系列（1）：编写高质量JavaScript代码的基本要点(转)</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
    	<section>
		<article class="clearfix">
		<p>才华横溢的<a href="http://www.phpied.com/" rel="external nofollow noreferrer">Stoyan Stefanov</a>，在他写的由<a href="http://oreilly.com/" rel="external nofollow noreferrer">O&rsquo;Reilly</a>初版的新书<a href="http://amzn.to/93szK7" rel="external nofollow noreferrer">《JavaScript Patterns》</a>(JavaScript模式)中，我想要是为我们的读者贡献其摘要，那会是件很美妙的事情。具体一点就是编写高质量JavaScript的一些要素，例如避免全局变量，使用单变量声明，在循环中预缓存length(长度)，遵循代码阅读，以及更多。</p>
<p>此摘要也包括一些与代码不太相关的习惯，但对整体代码的创建息息相关，包括撰写API文档、执行同行评审以及运行JSLint。这些习惯和最佳做法可以帮助你写出更好的，更易于理解和维护的代码，这些代码在几个月或是几年之后再回过头看看也是会觉得很自豪的。</p>
<h1>书写可维护的代码(Writing Maintainable Code )</h1>
<p>软 件bug的修复是昂贵的，并且随着时间的推移，这些bug的成本也会增加，尤其当这些bug潜伏并慢慢出现在已经发布的软件中时。当你发现bug 的时候就立即修复它是最好的，此时你代码要解决的问题在你脑中还是很清晰的。否则，你转移到其他任务，忘了那个特定的代码，一段时间后再去查看这些代码就 需要：</p>
<ul>
<li>花时间学习和理解这个问题</li>
<li>化时间是了解应该解决的问题代码</li>
</ul>
<p>还 有问题，特别对于大的项目或是公司，修复bug的这位伙计不是写代码的那个人（且发现bug和修复bug的不是同一个人）。因此，必须降低理解代 码花费的时间，无论是一段时间前你自己写的代码还是团队中的其他成员写的代码。这关系到底线（营业收入）和开发人员的幸福，因为我们更应该去开发新的激动 人心的事物而不是花几小时几天的时间去维护遗留代码。</p>
<p>另一个相关软件开发生命的事实是，读代码花费的时间要比写来得多。有时候，当你专注并深入思考某个问题的时候，你可以坐下来，一个下午写大量的代码。</p>
<p>你的代码很能很快就工作了，但是，随着应用的成熟，还会有很多其他的事情发生，这就要求你的进行进行审查，修改，和调整。例如：</p>
<ul>
<li>bug是暴露的</li>
<li>新功能被添加到应用程序</li>
<li>程序在新的环境下工作（例如，市场上出现新想浏览器）</li>
<li>代码改变用途</li>
<li>代码得完全从头重新，或移植到另一个架构上或者甚至使用另一种语言</li>
</ul>
<p>由于这些变化，很少人力数小时写的代码最终演变成花数周来阅读这些代码。这就是为什么创建可维护的代码对应用程序的成功至关重要。</p>
<p>可维护的代码意味着：</p>
<ul>
<li>可读的</li>
<li>一致的</li>
<li>可预测的</li>
<li>看上去就像是同一个人写的</li>
<li>已记录</li>
</ul>
<h1>最小全局变量(Minimizing Globals)</h1>
<p>JavaScript通过函数管理作用域。在函数内部声明的变量只在这个函数内部，函数外面不可用。另一方面，全局变量就是在任何函数外面声明的或是未声明直接简单使用的。</p>
<p>每 个JavaScript环境有一个全局对象，当你在任意的函数外面使用this的时候可以访问到。你创建的每一个全部变量都成了这个全局对象的属 性。在浏览器中，方便起见，该全局对象有个附加属性叫做window，此window(通常)指向该全局对象本身。下面的代码片段显示了如何在浏览器环境 中创建和访问的全局变量：</p>
<pre>myglobal = "hello"; // 不推荐写法console.log(myglobal); // "hello"console.log(window.myglobal); // "hello"console.log(window["myglobal"]); // "hello"console.log(this.myglobal); // "hello"</pre>

<h1>全局变量的问题</h1>
<p>全局变量的问题在于，你的JavaScript应用程序和web页面上的所有代码都共享了这些全局变量，他们住在同一个全局命名空间，所以当程序的两个不同部分定义同名但不同作用的全局变量的时候，命名冲突在所难免。</p>
<p>web页面包含不是该页面开发者所写的代码也是比较常见的，例如：</p>
<ul>
<li>第三方的JavaScript库</li>
<li>广告方的脚本代码</li>
<li>第三方用户跟踪和分析脚本代码</li>
<li>不同类型的小组件，标志和按钮</li>
</ul>
<p>比方说，该第三方脚本定义了一个全局变量，叫做result；接着，在你的函数中也定义一个名为result的全局变量。其结果就是后面的变量覆盖前面的，第三方脚本就一下子嗝屁啦！</p>
<p>因此，要想和其他脚本成为好邻居的话，尽可能少的使用全局变量是很重要的。在书中后面提到的一些减少全局变量的策略，例如命名空间模式或是函数立即自动执行，但是要想让全局变量少最重要的还是始终使用var来声明变量。</p>
<p>由于JavaScript的两个特征，不自觉地创建出全局变量是出乎意料的容易。首先，你可以甚至不需要声明就可以使用变量；第二，JavaScript有隐含的全局概念，意味着你不声明的任何变量都会成为一个全局对象属性。参考下面的代码：</p>
<pre>function sum(x, y) {   // 不推荐写法: 隐式全局变量    result = x + y;   return result;} </pre>
<p>此段代码中的<code>result</code>没有声明。代码照样运作正常，但在调用函数后你最后的结果就多一个全局命名空间，这可以是一个问题的根源。</p>
<p>经验法则是始终使用var声明变量，正如改进版的sum()函数所演示的：</p>
<pre>function sum(x, y) {   var result = x + y;   return result;}</pre>
<p>另一个创建隐式全局变量的反例就是使用任务链进行部分var声明。下面的片段中，<code>a</code>是本地变量但是<code>b</code>确实全局变量，这可能不是你希望发生的：</p>
<pre>// 反例，勿使用 function foo() {   var a = b = 0;   // ...}</pre>
<p>此现象发生的原因在于这个从右到左的赋值，首先，是赋值表达式<code>b = 0</code>，此情况下b是未声明的。这个表达式的返回值是0，然后这个0就分配给了通过var定义的这个局部变量a。换句话说，就好比你输入了：</p>
<pre>var a = (b = 0);</pre>
<p>如果你已经准备好声明变量，使用链分配是比较好的做法，不会产生任何意料之外的全局变量，如：</p>
<pre>function foo() {   var a, b;   // ... a = b = 0; // 两个均局部变量}</pre>

<blockquote><p>然而，另外一个避免全局变量的原因是可移植性。如果你想你的代码在不同的环境下（主机下）运行，使用全局变量如履薄冰，因为你会无意中覆盖你最初环境下不存在的主机对象（所以你原以为名称可以放心大胆地使用，实际上对于有些情况并不适用）。</p></blockquote>
<h1>忘记var的副作用(Side Effects When Forgetting var)</h1>
<p>隐式全局变量和明确定义的全局变量间有些小的差异，就是通过<code>delete</code>操作符让变量未定义的能力。</p>
<ul>
<li>通过var创建的全局变量（任何函数之外的程序中创建）是不能被删除的。</li>
<li>无var创建的隐式全局变量（无视是否在函数中创建）是能被删除的。</li>
</ul>
<p>这表明，在技术上，隐式全局变量并不是真正的全局变量，但它们是全局对象的属性。属性是可以通过<code>delete</code>操作符删除的，而变量是不能的：</p>
<pre>// 定义三个全局变量var global_var = 1;global_novar = 2; // 反面教材(function () {   global_fromfunc = 3; // 反面教材}());

// 试图删除delete global_var; // falsedelete global_novar; // truedelete global_fromfunc; // true

// 测试该删除typeof global_var; // "number"typeof global_novar; // "undefined"typeof global_fromfunc; // "undefined"</pre>
<p>在ES5严格模式下，未声明的变量（如在前面的代码片段中的两个反面教材）工作时会抛出一个错误。</p>
<h1>访问全局对象(Access to the Global Object)</h1>
<p>在浏览器中，全局对象可以通过<code>window</code>属性在代码的任何位置访问（除非你做了些比较出格的事情，像是声明了一个名为window的局部变量）。但是在其他环境下，这个方便的属性可能被叫做其他什么东西（甚至在程序中不可用）。如果你需要在没有硬编码的<code>window</code>标识符下访问全局对象，你可以在任何层级的函数作用域中做如下操作：</p>
<pre>var global = (function () {   return this;}());</pre>
<p>这种方法可以随时获得全局对象，因为其在函数中被当做函数调用了（不是通过<code>new</code>构造），<code>this</code>总 是指向全局对象。实际上这个病不适用于ECMAScript 5严格模式，所以，在严格模式下时，你必须采取不同的形式。例如，你正在开发一个JavaScript库，你可以将你的代码包裹在一个即时函数中，然后从 全局作用域中，传递一个引用指向this作为你即时函数的参数。</p>
<h1>单var形式（Single var Pattern）</h1>
<p>在函数顶部使用单var语句是比较有用的一种形式，其好处在于：</p>
<ul>
<li>提供了一个单一的地方去寻找功能所需要的所有局部变量</li>
<li>防止变量在定义之前使用的逻辑错误</li>
<li>帮助你记住声明的全局变量，因此较少了全局变量//zxx:此处我自己是有点晕乎的&hellip;</li>
<li>少代码（类型啊传值啊单线完成）</li>
</ul>
<p>单var形式长得就像下面这个样子：</p>
<pre>function func() {   var a = 1,       b = 2,       sum = a + b,       myobject = {},       i,       j;   // function body...}</pre>
<p>您可以使用一个var语句声明多个变量，并以逗号分隔。像这种初始化变量同时初始化值的做法是很好的。这样子可以防止逻辑错误（所有未初始化但声明的变量的初始值是<code>undefined</code>）和增加代码的可读性。在你看到代码后，你可以根据初始化的值知道这些变量大致的用途，例如是要当作对象呢还是当作整数来使。</p>
<p>你也可以在声明的时候做一些实际的工作，例如前面代码中的<code>sum = a + b</code>这个情况，另外一个例子就是当你使用DOM（文档对象模型）引用时，你可以使用单一的var把DOM引用一起指定为局部变量，就如下面代码所示的：</p>
<pre>function updateElement() {   var el = document.getElementById("result"),       style = el.style;   // 使用el和style干点其他什么事...}</pre>

<h1>预解析：var散布的问题(Hoisting: A Problem with Scattered vars)</h1>
<p>JavaScript 中，你可以在函数的任何位置声明多个var语句，并且它们就好像是在函数顶部声明一样发挥作用，这种行为称为 hoisting（悬置/置顶解析/预解析）。当你使用了一个变量，然后不久在函数中又重新声明的话，就可能产生逻辑错误。对于JavaScript，只 要你的变量是在同一个作用域中（同一函数），它都被当做是声明的，即使是它在var声明前使用的时候。看下面这个例子：</p>
<pre>// 反例myname = "global"; // 全局变量function func() {    alert(myname); // "undefined"    var myname = "local";    alert(myname); // "local"}func();</pre>
<p>在 这个例子中，你可能会以为第一个alert弹出的是&rdquo;global&rdquo;，第二个弹出&rdquo;loacl&rdquo;。这种期许是可以理解的，因为在第一个alert 的时候，myname未声明，此时函数肯定很自然而然地看全局变量myname，但是，实际上并不是这么工作的。第一个alert会弹 出&rdquo;undefined&rdquo;是因为myname被当做了函数的局部变量（尽管是之后声明的），所有的变量声明当被悬置到函数的顶部了。因此，为了避免这种混 乱，最好是预先声明你想使用的全部变量。</p>
<p>上面的代码片段执行的行为可能就像下面这样：</p>
<pre>myname = "global"; // global variablefunction func() {   var myname; // 等同于 -&gt; var myname = undefined;   alert(myname); // "undefined"   myname = "local";   alert(myname); // "local"}func();</pre>

<blockquote><p>为 了完整，我们再提一提执行层面的稍微复杂点的东西。代码处理分两个阶段，第一阶段是变量，函数声明，以及正常格式的参数创建，这是一个解析和进入 上下文 的阶段。第二个阶段是代码执行，函数表达式和不合格的标识符（为声明的变量）被创建。但是，出于实用的目的，我们就采用了&rdquo;hoisting&rdquo;这个概念， 这种ECMAScript标准中并未定义，通常用来描述行为。</p></blockquote>
<h1>for循环(for Loops)</h1>
<p>在<code>for</code>循环中，你可以循环取得数组或是数组类似对象的值，譬如<code>arguments</code>和<code>HTMLCollection</code>对象。通常的循环形式如下：</p>
<pre>// 次佳的循环for (var i = 0; i &lt; myarray.length; i++) {   // 使用myarray[i]做点什么}</pre>
<p>这种形式的循环的不足在于每次循环的时候数组的长度都要去获取下。这回降低你的代码，尤其当<code>myarray</code>不是数组，而是一个<code>HTMLCollection</code>对象的时候。</p>
<p><code>HTMLCollections</code>指的是DOM方法返回的对象，例如：</p>
<pre>document.getElementsByName()document.getElementsByClassName()document.getElementsByTagName()</pre>
<p>还有其他一些<code>HTMLCollections</code>，这些是在DOM标准之前引进并且现在还在使用的。有：</p>
<pre>document.images: 页面上所有的图片元素document.links : 所有a标签元素document.forms : 所有表单document.forms[0].elements : 页面上第一个表单中的所有域</pre>
<p>集合的麻烦在于它们实时查询基本文档（HTML页面）。这意味着每次你访问任何集合的长度，你要实时查询DOM，而DOM操作一般都是比较昂贵的。</p>
<p>这就是为什么当你循环获取值时，缓存数组(或集合)的长度是比较好的形式，正如下面代码显示的：</p>
<pre>for (var i = 0, max = myarray.length; i &lt; max; i++) {   // 使用myarray[i]做点什么}</pre>
<p>这样，在这个循环过程中，你只检索了一次长度值。</p>
<p>在所有浏览器下，循环获取内容时缓存<code>HTMLCollections</code>的长度是更快的，2倍(Safari3)到190倍(IE7)之间。//zxx:此数据貌似很老，仅供参考</p>
<p>注意到，当你明确想要修改循环中的集合的时候（例如，添加更多的DOM元素），你可能更喜欢长度更新而不是常量。</p>
<p>伴随着单var形式，你可以把变量从循环中提出来，就像下面这样：</p>
<pre>function looper() {   var i = 0,        max,        myarray = [];   // ...   for (i = 0, max = myarray.length; i &lt; max; i++) {      // 使用myarray[i]做点什么   }}</pre>
<p>这种形式具有一致性的好处，因为你坚持了单一var形式。不足在于当重构代码的时候，复制和粘贴整个循环有点困难。例如，你从一个函数复制了一个循环到另一个函数，你不得不去确定你能够把<code>i</code>和<code>max</code>引入新的函数（如果在这里没有用的话，很有可能你要从原函数中把它们删掉）。</p>
<p>最后一个需要对循环进行调整的是使用下面表达式之一来替换<code>i++</code>。</p>
<pre>i = i + 1i += 1</pre>
<p>JSLint提示您这样做，原因是<code>++</code>和<code>&ndash;-</code>促进了&ldquo;过分棘手(excessive trickiness)&rdquo;。//zxx:这里比较难翻译，我想本意应该是让代码变得更加的棘手<br />如果你直接无视它，JSLint的<code>plusplus</code>选项会是<code>false</code>（默认是default）。</p>
<p>还有两种变化的形式，其又有了些微改进，因为：</p>
<ul>
<li>少了一个变量(无max)</li>
<li>向下数到0，通常更快，因为和0做比较要比和数组长度或是其他不是0的东西作比较更有效率</li>
</ul>

<pre>//第一种变化的形式：

var i, myarray = [];for (i = myarray.length; i&ndash;-;) {   // 使用myarray[i]做点什么}

//第二种使用while循环：

var myarray = [],    i = myarray.length;while (i&ndash;-) {   // 使用myarray[i]做点什么}</pre>
<p>这些小的改进只体现在性能上，此外JSLint会对使用i&ndash;-加以抱怨。</p>
<h1>for-in循环(for-in Loops)</h1>
<p><code>for-in</code>循环应该用在非数组对象的遍历上，使用<code>for-in</code>进行循环也被称为&ldquo;枚举&rdquo;。</p>
<p>从技术上将，你可以使用<code>for-in</code>循环数组（因为JavaScript中数组也是对象），但这是不推荐的。因为如果数组对象已被自定义的功能增强，就可能发生逻辑错误。另外，在for-in中，属性列表的顺序（序列）是不能保证的。所以最好数组使用正常的for循环，对象使用for-in循环。</p>
<p>有个很重要的<code>hasOwnProperty()</code>方法，当遍历对象属性的时候可以过滤掉从原型链上下来的属性。</p>
<p>思考下面一段代码：</p>
<pre>// 对象var man = {   hands: 2,   legs: 2,   heads: 1};

// 在代码的某个地方// 一个方法添加给了所有对象if (typeof Object.prototype.clone === "undefined") {   Object.prototype.clone = function () {};}</pre>
<p>在 这个例子中，我们有一个使用对象字面量定义的名叫man的对象。在man定义完成后的某个地方，在对象原型上增加了一个很有用的名叫 clone()的方法。此原型链是实时的，这就意味着所有的对象自动可以访问新的方法。为了避免枚举man的时候出现clone()方法，你需要应用<code>hasOwnProperty()</code>方法过滤原型属性。如果不做过滤，会导致clone()函数显示出来，在大多数情况下这是不希望出现的。</p>
<pre>// 1.// for-in 循环for (var i in man) {   if (man.hasOwnProperty(i)) { // 过滤      console.log(i, ":", man[i]);   }}/* 控制台显示结果hands : 2legs : 2heads : 1*/// 2.// 反面例子:// for-in loop without checking hasOwnProperty()for (var i in man) {   console.log(i, ":", man[i]);}/*控制台显示结果hands : 2legs : 2heads : 1clone: function()*/</pre>
<p>另外一种使用<code>hasOwnProperty()</code>的形式是取消Object.prototype上的方法。像是：</p>
<pre>for (var i in man) {   if (Object.prototype.hasOwnProperty.call(man, i)) { // 过滤      console.log(i, ":", man[i]);   }}</pre>
<p>其好处在于在man对象重新定义hasOwnProperty情况下避免命名冲突。也避免了长属性查找对象的所有方法，你可以使用局部变量&ldquo;缓存&rdquo;它。</p>
<pre>var i, hasOwn = Object.prototype.hasOwnProperty;for (i in man) {    if (hasOwn.call(man, i)) { // 过滤        console.log(i, ":", man[i]);    }}</pre>

<blockquote><p>严格来说，不使用<code>hasOwnProperty()</code>并不是一个错误。根据任务以及你对代码的自信程度，你可以跳过它以提高些许的循环速度。但是当你对当前对象内容（和其原型链）不确定的时候，添加<code>hasOwnProperty()</code>更加保险些。</p></blockquote>
<p>格式化的变化（通不过JSLint）会直接忽略掉花括号，把if语句放到同一行上。其优点在于循环语句读起来就像一个完整的想法（每个元素都有一个自己的属性&rdquo;X&rdquo;，使用&rdquo;X&rdquo;干点什么）：</p>
<pre>// 警告： 通不过JSLint检测var i, hasOwn = Object.prototype.hasOwnProperty;for (i in man) if (hasOwn.call(man, i)) { // 过滤    console.log(i, ":", man[i]);}</pre>

<h1>（不）扩展内置原型((Not) Augmenting Built-in Prototypes)</h1>
<p>扩增构造函数的prototype属性是个很强大的增加功能的方法，但有时候它太强大了。</p>
<p>增 加内置的构造函数原型（如Object(), Array(), 或Function()）挺诱人的，但是这严重降低了可维护性，因为它让你的代码变得难以预测。使用你代码的其他开发人员很可能更期望使用内置的 JavaScript方法来持续不断地工作，而不是你另加的方法。</p>
<p>另外，属性添加到原型中，可能会导致不使用hasOwnProperty属性时在循环中显示出来，这会造成混乱。</p>
<p>因此，不增加内置原型是最好的。你可以指定一个规则，仅当下面的条件均满足时例外：</p>
<ul>
<li>可以预期将来的ECMAScript版本或是JavaScript实现将一直将此功能当作内置方法来实现。例如，你可以添加ECMAScript 5中描述的方法，一直到各个浏览器都迎头赶上。这种情况下，你只是提前定义了有用的方法。</li>
<li>如果您检查您的自定义属性或方法已不存在&mdash;&mdash;也许已经在代码的其他地方实现或已经是你支持的浏览器JavaScript引擎部分。</li>
<li>你清楚地文档记录并和团队交流了变化。</li>
</ul>
<p>如果这三个条件得到满足，你可以给原型进行自定义的添加，形式如下：</p>
<pre>if (typeof Object.protoype.myMethod !== "function") {   Object.protoype.myMethod = function () {      // 实现...   };}</pre>

<h1>switch模式(switch Pattern)</h1>
<p>你可以通过类似下面形式的switch语句增强可读性和健壮性：</p>
<pre>var inspect_me = 0,    result = ‘‘;switch (inspect_me) {case 0:   result = "zero";   break;case 1:   result = "one";   break;default:   result = "unknown";}</pre>
<p>这个简单的例子中所遵循的风格约定如下：</p>
<ul>
<li>每个case和switch对齐（花括号缩进规则除外）</li>
<li>每个case中代码缩进</li>
<li>每个case以break清除结束</li>
<li>避免贯穿（故意忽略break）。如果你非常确信贯穿是最好的方法，务必记录此情况，因为对于有些阅读人而言，它们可能看起来是错误的。</li>
<li>以default结束switch：确保总有健全的结果，即使无情况匹配。</li>
</ul>
<h1>避免隐式类型转换(Avoiding Implied Typecasting )</h1>
<p>JavaScript的变量在比较的时候会隐式类型转换。这就是为什么一些诸如：false == 0 或 &ldquo;&rdquo; == 0 返回的结果是true。为避免引起混乱的隐含类型转换，在你比较值和表达式类型的时候始终使用===和!==操作符。</p>
<pre>var zero = 0;if (zero === false) {   // 不执行，因为zero为0, 而不是false}

// 反面示例if (zero == false) {   // 执行了...}</pre>
<p>还有另外一种思想观点认为==就足够了===是多余的。例如，当你使用typeof你就知道它会返回一个字符串，所以没有使用严格相等的理由。然而，JSLint要求严格相等，它使代码看上去更有一致性，可以降低代码阅读时的精力消耗。（&ldquo;==是故意的还是一个疏漏？&rdquo;）</p>
<h1>避免(Avoiding) eval()</h1>
<p>如 果你现在的代码中使用了eval()，记住该咒语&ldquo;eval()是魔鬼&rdquo;。此方法接受任意的字符串，并当作JavaScript代码来处理。当有 问题的代码是事先知道的（不是运行时确定的），没有理由使用eval()。如果代码是在运行时动态生成，有一个更好的方式不使用eval而达到同样的目 标。例如，用方括号表示法来访问动态属性会更好更简单：</p>
<pre>// 反面示例var property = "name";alert(eval("obj." + property));

// 更好的var property = "name";alert(obj[property]);</pre>
<p>使 用eval()也带来了安全隐患，因为被执行的代码（例如从网络来）可能已被篡改。这是个很常见的反面教材，当处理Ajax请求得到的JSON 相应的时候。在这些情况下，最好使用JavaScript内置方法来解析JSON相应，以确保安全和有效。若浏览器不支持JSON.parse()，你可 以使用来自JSON.org的库。</p>
<p>同样重要的是要记住，给setInterval(), setTimeout()和Function()构造函数传递字符串，大部分情况下，与使用eval()是类似的，因此要避免。在幕后，JavaScript仍需要评估和执行你给程序传递的字符串：</p>
<pre>// 反面示例setTimeout("myFunc()", 1000);setTimeout("myFunc(1, 2, 3)", 1000);

// 更好的setTimeout(myFunc, 1000);setTimeout(function () {   myFunc(1, 2, 3);}, 1000);</pre>
<p>使 用新的Function()构造就类似于eval()，应小心接近。这可能是一个强大的构造，但往往被误用。如果你绝对必须使用eval()，你 可以考虑使用new Function()代替。有一个小的潜在好处，因为在新Function()中作代码评估是在局部函数作用域中运行，所以代码中任何被评估的通过var 定义的变量都不会自动变成全局变量。另一种方法来阻止自动全局变量是封装eval()调用到一个即时函数中。</p>
<p>考虑下面这个例子，这里仅<code>un</code>作为全局变量污染了命名空间。</p>
<pre>console.log(typeof un);    // "undefined"console.log(typeof deux); // "undefined"console.log(typeof trois); // "undefined"

var jsstring = "var un = 1; console.log(un);";eval(jsstring); // logs "1"

jsstring = "var deux = 2; console.log(deux);";new Function(jsstring)(); // logs "2"

jsstring = "var trois = 3; console.log(trois);";(function () {   eval(jsstring);}()); // logs "3"

console.log(typeof un); // numberconsole.log(typeof deux); // "undefined"console.log(typeof trois); // "undefined"</pre>
<p>另 一间eval()和Function构造不同的是eval()可以干扰作用域链，而Function()更安分守己些。不管你在哪里执行 Function()，它只看到全局作用域。所以其能很好的避免本地变量污染。在下面这个例子中，eval()可以访问和修改它外部作用域中的变量，这是 Function做不来的（注意到使用Function和new Function是相同的）。</p>
<pre>(function () {   var local = 1;   eval("local = 3; console.log(local)"); // logs "3"   console.log(local); // logs "3"}());

(function () {   var local = 1;   Function("console.log(typeof local);")(); // logs undefined}());</pre>

<h1>parseInt()下的数值转换(Number Conversions with parseInt())</h1>
<p>使 用parseInt()你可以从字符串中获取数值，该方法接受另一个基数参数，这经常省略，但不应该。当字符串以&rdquo;0&Prime;开头的时候就有可能会出问 题，例如，部分时间进入表单域，在ECMAScript 3中，开头为&rdquo;0&Prime;的字符串被当做8进制处理了，但这已在ECMAScript 5中改变了。为了避免矛盾和意外的结果，总是指定基数参数。</p>
<pre>var month = "06",    year = "09";month = parseInt(month, 10);year = parseInt(year, 10);</pre>
<p>此例中，如果你忽略了基数参数，如parseInt(year)，返回的值将是0，因为&ldquo;09&rdquo;被当做8进制（好比执行 parseInt( year, 8 )），而09在8进制中不是个有效数字。</p>
<p>替换方法是将字符串转换成数字，包括：</p>
<pre>+"08" // 结果是 8Number("08") // 8</pre>
<p>这些通常快于parseInt()，因为parseInt()方法，顾名思意，不是简单地解析与转换。但是，如果你想输入例如&ldquo;08 hello&rdquo;，parseInt()将返回数字，而其它以NaN告终。</p>
<h1>编码规范(Coding Conventions)</h1>
<p>建立和遵循编码规范是很重要的，这让你的代码保持一致性，可预测，更易于阅读和理解。一个新的开发者加入这个团队可以通读规范，理解其它团队成员书写的代码，更快上手干活。</p>
<p>许 多激烈的争论发生会议上或是邮件列表上，问题往往针对某些代码规范的特定方面（例如代码缩进，是Tab制表符键还是space空格键）。如果你是 你组织中建议采用规范的，准备好面对各种反对的或是听起来不同但很强烈的观点。要记住，建立和坚定不移地遵循规范要比纠结于规范的细节重要的多。</p>
<h1>缩进(Indentation)</h1>
<p>代码没有缩进基本上就不能读了。唯一糟糕的事情就是不一致的缩进，因为它看上去像是遵循了规范，但是可能一路上伴随着混乱和惊奇。重要的是规范地使用缩进。</p>
<p>一些开发人员更喜欢用tab制表符缩进，因为任何人都可以调整他们的编辑器以自己喜欢的空格数来显示Tab。有些人喜欢空格&mdash;&mdash;通常四个，这都无所谓，只要团队每个人都遵循同一个规范就好了。这本书，例如，使用四个空格缩进，这也是JSLint中默认的缩进。</p>
<p>什么应该缩进呢？规则很简单&mdash;&mdash;花括号里面的东西。这就意味着函数体，循环 (do, while, for, for-in)，if，switch，以及对象字面量中的对象属性。下面的代码就是使用缩进的示例：</p>
<pre>function outer(a, b) {    var c = 1,        d = 2,        inner;    if (a &gt; b) {        inner = function () {            return {                r: c - d            };        };    } else {        inner = function () {            return {                r: c + d            };        };    }    return inner;}</pre>

<h1>花括号{}(Curly Braces)</h1>
<p>花括号（亦称大括号，下同）应总被使用，即使在它们为可选的时候。技术上将，在in或是for中如果语句仅一条，花括号是不需要的，但是你还是应该总是使用它们，这会让代码更有持续性和易于更新。</p>
<p>想象下你有一个只有一条语句的for循环，你可以忽略花括号，而没有解析的错误。</p>
<pre>// 糟糕的实例for (var i = 0; i &lt; 10; i += 1)   alert(i);</pre>
<p>但是，如果，后来，主体循环部分又增加了行代码？</p>
<pre>// 糟糕的实例for (var i = 0; i &lt; 10; i += 1)   alert(i);   alert(i + " is " + (i % 2 ? "odd" : "even"));</pre>
<p>第二个alert已经在循环之外，缩进可能欺骗了你。为了长远打算，最好总是使用花括号，即时值一行代码：</p>
<pre>// 好的实例for (var i = 0; i &lt; 10; i += 1) {   alert(i);}</pre>
<p>if条件类似：</p>
<pre>// 坏if (true)   alert(1);else   alert(2);

// 好if (true) {   alert(1);} else {   alert(2);}</pre>

<h1>左花括号的位置(Opening Brace Location)</h1>
<p>开发人员对于左大括号的位置有着不同的偏好&mdash;&mdash;在同一行或是下一行。</p>
<pre>if (true) {   alert("It‘s TRUE!");}

//或

if (true){   alert("It‘s TRUE!");}</pre>
<p>这<br />
个实例中，仁者见仁智者见智，但也有个案，括号位置不同会有不同的行为表现。这是因为分号插入机制(semicolon insertion<br />
mechanism)&mdash;&mdash;JavaScript是不挑剔的，当你选择不使用分号结束一行代码时JavaScript会自己帮你补上。这种行为可能会导致麻<br />
  烦，如当你返回对象字面量，而左括号却在下一行的时候：</p>
<pre>// 警告： 意外的返回值function func() {   return  // 下面代码不执行   {      name : "Batman"   }}</pre>
<p>如果你希望函数返回一个含有name属性的对象，你会惊讶。由于隐含分号，函数返回undefined。前面的代码等价于：</p>
<pre>// 警告： 意外的返回值function func() {   return undefined;  // 下面代码不执行   {      name : "Batman"   }}</pre>
<p>总之，总是使用花括号，并始终把在与之前的语句放在同一行：</p>
<pre>function func() {   return {      name : "Batman"   };}</pre>

<blockquote><p>关于分号注：就像使用花括号，你应该总是使用分号，即使他们可由JavaScript解析器隐式创建。这不仅促进更科学和更严格的代码，而且有助于解决存有疑惑的地方，就如前面的例子显示。</p></blockquote>
<h1>空格(White Space)</h1>
<p>空格的使用同样有助于改善代码的可读性和一致性。在写英文句子的时候，在逗号和句号后面会使用间隔。在JavaScript中，你可以按照同样的逻辑在列表模样表达式（相当于逗号）和结束语句（相对于完成了&ldquo;想法&rdquo;）后面添加间隔。</p>
<p>适合使用空格的地方包括：</p>
<ul>
<li>for循环分号分开后的的部分：如<code>for (var i = 0; i &lt; 10; i += 1) {...}</code></li>
<li>for循环中初始化的多变量(i和max)：<code>for (var i = 0, max = 10; i &lt; max; i += 1) {...}</code></li>
<li>分隔数组项的逗号的后面：<code>var a = [1, 2, 3];</code></li>
<li>对象属性逗号的后面以及分隔属性名和属性值的冒号的后面：<code>var o = {a: 1, b: 2};</code></li>
<li>限定函数参数：<code>myFunc(a, b, c)</code></li>
<li>函数声明的花括号的前面：<code>function myFunc() {}</code></li>
<li>匿名函数表达式function的后面：<code>var myFunc = function () {};</code></li>
</ul>
<p>使用空格分开所有的操作符和操作对象是另一个不错的使用，这意味着在<code>+, -, *, =, &lt;, &gt;, &lt;=, &gt;=, ===, !==, &amp;&amp;, ||, +=</code>等前后都需要空格。</p>
<pre>// 宽松一致的间距// 使代码更易读// 使得更加&ldquo;透气&rdquo;var d = 0,    a = b + 1;if (a &amp;&amp; b &amp;&amp; c) {    d = a % c;    a += d;}

// 反面例子// 缺失或间距不一// 使代码变得疑惑var d = 0,    a = b + 1;if (a&amp;&amp;b&amp;&amp;c) {    d=a % c;    a+= d;}</pre>
<p>最后需要注意的一个空格&mdash;&mdash;花括号间距。最好使用空格：</p>
<ul>
<li>函数、if-else语句、循环、对象字面量的左花括号的前面({)</li>
<li>else或while之间的右花括号(})</li>
</ul>
<p>空格使用的一点不足就是增加了文件的大小，但是压缩无此问题。</p>
<blockquote><p>有一个经常被忽略的代码可读性方面是垂直空格的使用。你可以使用空行来分隔代码单元，就像是文学作品中使用段落分隔一样。</p></blockquote>
<h3>命名规范(Naming Conventions)</h3>
<p>另一种方法让你的代码更具可预测性和可维护性是采用命名规范。这就意味着你需要用同一种形式给你的变量和函数命名。</p>
<p>下面是建议的一些命名规范，你可以原样采用，也可以根据自己的喜好作调整。同样，遵循规范要比规范是什么更重要。</p>
<h3>以大写字母写构造函数(Capitalizing Constructors)</h3>
<p>JavaScript并没有类，但有new调用的构造函数：</p>
<pre>var adam = new Person();  </pre>
<p>因为构造函数仍仅仅是函数，仅看函数名就可以帮助告诉你这应该是一个构造函数还是一个正常的函数。</p>
<p>命名构造函数时首字母大写具有暗示作用，使用小写命名的函数和方法不应该使用new调用：</p>
<pre>function MyConstructor() {...}function myFunction() {...}</pre>

<h1>分隔单词(Separating Words)</h1>
<p>当你的变量或是函数名有多个单词的时候，最好单词的分离遵循统一的规范，有一个常见的做法被称作&ldquo;驼峰(Camel)命名法&rdquo;，就是单词小写，每个单词的首字母大写。</p>
<p>对于构造函数，可以使用大驼峰式命名法(upper camel case)，如<code>MyConstructor()</code>。对于函数和方法名称，你可以使用小驼峰式命名法(lower camel case)，像是<code>myFunction(), calculateArea()</code>和<code>getFirstName()</code>。</p>
<p>要是变量不是函数呢？开发者通常使用小驼峰式命名法，但还有另外一种做法就是所有单词小写以下划线连接：例如，<code>first_name, favorite_bands, </code>和<code> old_company_name</code>，这种标记法帮你直观地区分函数和其他标识&mdash;&mdash;原型和对象。</p>
<p>ECMAScript的属性和方法均使用Camel标记法，尽管多字的属性名称是罕见的（正则表达式对象的lastIndex和ignoreCase属性）。</p>
<h1>其它命名形式(Other Naming Patterns)</h1>
<p>有时，开发人员使用命名规范来弥补或替代语言特性。</p>
<p>例如，JavaScript中没有定义常量的方法（尽管有些内置的像Number, MAX_VALUE），所以开发者都采用全部单词大写的规范来命名这个程序生命周期中都不会改变的变量，如：</p>
<pre>// 珍贵常数，只可远观var PI = 3.14,    MAX_WIDTH = 800;</pre>
<p>还有另外一个完全大写的惯例：全局变量名字全部大写。全部大写命名全局变量可以加强减小全局变量数量的实践，同时让它们易于区分。</p>
<p>另外一种使用规范来模拟功能的是私有成员。虽然可以在JavaScript中实现真正的私有，但是开发者发现仅仅使用一个下划线前缀来表示一个私有属性或方法会更容易些。考虑下面的例子：</p>
<pre>var person = {    getName: function () {        return this._getFirst() + ‘ ‘ + this._getLast();    },

    _getFirst: function () {        // ...    },    _getLast: function () {        // ...    }};</pre>
<p>在此例中，<code>getName()</code>就表示公共方法，部分稳定的API。而<code>_getFirst()</code>和<code>_getLast()</code>则表明了私有。它们仍然是正常的公共方法，但是使用下划线前缀来警告person对象的使用者这些方法在下一个版本中时不能保证工作的，是不能直接使用的。注意，JSLint有些不鸟下划线前缀，除非你设置了noman选项为:false。</p>
<p>下面是一些常见的_private规范：</p>
<ul>
<li>使用尾下划线表示私有，如name_和getElements_()</li>
<li>使用一个下划线前缀表_protected（保护）属性，两个下划线前缀表示__private （私有）属性</li>
<li>Firefox中一些内置的变量属性不属于该语言的技术部分，使用两个前下划线和两个后下划线表示，如：__proto__和__parent__。</li>
</ul>
<h1>注释(Writing Comments)</h1>
<p>你必须注释你的代码，即使不会有其他人向你一样接触它。通常，当你深入研究一个问题，你会很清楚的知道这个代码是干嘛用的，但是，当你一周之后再回来看的时候，想必也要耗掉不少脑细胞去搞明白到底怎么工作的。</p>
<p>很 显然，注释不能走极端：每个单独变量或是单独一行。但是，你通常应该记录所有的函数，它们的参数和返回值，或是任何不寻常的技术和方法。要想到注 释可以给你代码未来的阅读者以诸多提示；阅读者需要的是（不要读太多的东西）仅注释和函数属性名来理解你的代码。例如，当你有五六行程序执行特定的任务， 如果你提供了一行代码目的以及为什么在这里的描述的话，阅读者就可以直接跳过这段细节。没有硬性规定注释代码比，代码的某些部分（如正则表达式）可能注释 要比代码多。</p>
<blockquote><p>最重要的习惯，然而也是最难遵守的，就是保持注释的及时更新，因为过时的注释比没有注释更加的误导人。</p></blockquote>
<h1>关于作者（About the Author ）</h1>
<p>Stoyan Stefanov是Yahoo!web开发人员，多个O‘Reilly书籍的作者、投稿者和技术评审。他经常在会议和他的博客<a href="http://www.zhangxinxu.com/wordpress/2010/10/%e7%bf%bb%e8%af%91-%e9%ab%98%e8%b4%a8%e9%87%8fjavascript%e4%bb%a3%e7%a0%81%e4%b9%a6%e5%86%99%e5%9f%ba%e6%9c%ac%e8%a6%81%e7%82%b9/www.phpied.com" rel="external nofollow noreferrer">www.phpied.com</a>上发表web开发主题的演讲。Stoyan还是smush.it图片优化工具的创造者，YUI贡献者，雅虎性能优化工具YSlow 2.0的架构设计师。</p>
<p>本文转自：http://www.zhangxinxu.com/wordpress/?p=1173</p>
<p>英文原文：http://net.tutsplus.com/tutorials/javascript-ajax/the-essentials-of-writing-high-quality-javascript/</p>
<h1>同步与结束语</h1>
<p>本文已同步至目录索引：<a href="http://www.cnblogs.com/TomXu/archive/2011/12/15/2288411.html" rel="external nofollow noreferrer">深入理解JavaScript系列</a></p>
<p>深入理解JavaScript系列文章，包括了原创，翻译，转载等各类型的文章，如果对你有用，请推荐支持一把，给大叔写作的动力。</p>
<h1><a href="http://www.cnblogs.com/TomXu/" rel="external nofollow noreferrer">汤姆大叔</a></h1>
<p>引用地址: <a href="http://www.cnblogs.com/yuzhongwusan/archive/2012/03/21/2409675.html" rel="external nofollow noreferrer">http://www.cnblogs.com/yuzhongwusan/archive/2012/03/21/2409675.html</a></p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-11 12:54:12 </div>
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.biecuoliao.com/tag/color/" title="color">color</a>, <a href="https://www.biecuoliao.com/tag/style/" title="style">style</a>, <a href="https://www.biecuoliao.com/tag/http/" title="http">http</a>, <a href="https://www.biecuoliao.com/tag/%e4%bd%bf%e7%94%a8/" title="使用">使用</a>, <a href="https://www.biecuoliao.com/tag/java/" title="java">java</a>, <a href="https://www.biecuoliao.com/tag/blog/" title="blog">blog</a>        </div> -->
	</section>
	
	

		<div id="similar" class="row">

		<h3>深入理解JavaScript系列（1）：编写高质量JavaScript代码的基本要点(转)的相关文章</h3>

						<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/VMG5ZG3.html" rel="bookmark">0003&period;深入理解JavaScript系列学习：编写高质量JavaScript代码的基本要点</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				推荐 汤姆大叔博客园深入理解JavaScript系列 此文来源:http://www.cnblogs.com/TomXu/archive/2011/12/28/2286877.html 书写可维护的代码(Writing Maintainable Code ) 即 代码的可读写维护性 博客园&lt;行者自若的技术笔记&gt; 中参考代码规范与读写可维护性 可作为参考,我也转载了文章到自己的博客园 http://www.cnblogs.com/wolongjv/articles/5937898.html 概括			</div>
		</article>
	</section>
						<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MgE2ap3.html" rel="bookmark">JavaScript手札：《编写高质量JS代码的68个有效方法》（一）（1~5）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				编写高质量JS代码的68个有效方法(一) *:first-child { margin-top: 0 !important; } body&gt;*:last-child { margin-bottom: 0 !important; } /* BLOCKS =============================================================================*/ p, blockquote, ul, ol, dl, table, pre { marg			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MgneG84.html" rel="bookmark">编写高质量JavaScript代码的68个有效方法</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				简介: &lt;Effective JavaScript:编写高质量JavaScript代码的68个有效方法&gt;共分为7章,分别涵盖JavaScript的不同主题.第1章主要讲述最基本的主题,如版本.类型转换要点.运算符注意事项和分号局限等.第2章主要讲解变量作用域,介绍此方面的一些基本概念,以及一些最佳实践经验.第3章主要讲解函数的使用,深刻解析函数.方法和类,并教会读者在不同的环境下高效使用函数.第4章主要讲解原型和对象,分析JavaScript的继承机制以及原型和对象使用的最佳实践和原则.第5章			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/4JKYPlM.html" rel="bookmark">编写高质量javascript代码的基本要点</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				javascript入门比较快,基础方面也比较简单,但如果想写出高质量的javascript代码也绝非易事,下图是在下整理的编写高质量javascript代码的基本要点,希望能够对各位有所帮助.			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0RjW2R0.html" rel="bookmark">编写高质量JS代码的68个有效方法（三）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				[20141030]编写高质量JS代码的68个有效方法(三) *:first-child { margin-top: 0 !important; } body&gt;*:last-child { margin-bottom: 0 !important; } /* BLOCKS =============================================================================*/ p, blockquote, ul, ol, dl, table,			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/412pdXM.html" rel="bookmark">&lbrack;编写高质量iOS代码的52个有效方法&rsqb;（三）消息和运行期</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				[编写高质量iOS代码的52个有效方法](三)消息和运行期 参考书籍:&lt;Effective Objective-C 2.0&gt; [英] Matt Galloway 先睹为快 11.理解objc_msgSend的作用 12.理解消息转发机制 13.用&quot;方法调配技术&quot;调试&quot;黑盒方法&quot; 14.理解&quot;类对象&quot;的用意 目录 编写高质量iOS代码的52个有效方法三消息和运行期 先睹为快 目录 第11条理解objc_msgSend的作用 第12条理解			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/49b57WM.html" rel="bookmark">&lbrack;编写高质量iOS代码的52个有效方法&rsqb;（十）Grand Central Dispatch（GCD）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				[编写高质量iOS代码的52个有效方法](十)Grand Central Dispatch(GCD) 参考书籍:&lt;Effective Objective-C 2.0&gt; [英] Matt Galloway 先睹为快 41.多用派发队列,少用同步锁 42.多用GCD,少用performSelector系列方法 43.掌握GCD及操作队列的使用时机 44.通过Dispatch Group机制,根据系统资源状况来执行任务 45.使用dispatch_once来执行只需要运行一次的线程安全代码 46.不			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/35w1JjM.html" rel="bookmark">编写高质量Python代码的59个有效方法</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				作者Brett Slatkin是 Google公司高级软件工程师.他是Google消费者调查项目的工程主管及联合创始人,曾从事Google App Engine的Python基础架构工作,并利用Python来管理众多的Google服务器.Slatkin也是PubSubHubbub协议的联合创始人,还用Python为Google实现了针对该协议的系统.他拥有哥伦比亚大学计算机工程专业学士学位. 精彩书评 &quot;Slatkin所写的这本书,其每个条目(item)都是一项独立的教程,并包含它自己的源代码.			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0lLPYp0.html" rel="bookmark">编写高质量JS代码的68个有效方法（七）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				[20141220]编写高质量JS代码的68个有效方法(七) *:first-child { margin-top: 0 !important; } body&gt;*:last-child { margin-bottom: 0 !important; } /* BLOCKS =============================================================================*/ p, blockquote, ul, ol, dl, table,			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/B0R1ZvM.html" rel="bookmark" class="title">Android视频录制从不入门到入门系列教程&lpar;二&rpar;&mdash;&mdash;&mdash;&mdash;显示视频图像</a>
					<div>
						1.创建一个空的工程,注意声明下列权限: &lt;uses-permission android:name=&quot;android.permission.CAMERA&quot;/&gt; &lt ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/38Z5l2M.html" rel="bookmark" class="title">WebView&amp;&num;183&semi;开发指南</a>
					<div>
						WebView·开车指南 作者:凌俊琦链接:https://zhuanlan.zhihu.com/p/22247021来源:知乎著作权归作者所有.商业转载请联系作者获得授权,非商业转载请注明出处. T ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0j5myAM.html" rel="bookmark" class="title">Hdu 3687 National Day Parade（暴力）</a>
					<div>
						题目地址:http://acm.split.hdu.edu.cn/showproblem.php?pid=3687 思路:暴力,枚举每列(矩形开始的列),将同一行的人按列从小到大排序,则每个人的移动距 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3rEZzg0.html" rel="bookmark" class="title">HDU - 5190 - Go to movies  &amp;amp&semi;&amp;amp&semi;  5191 - Building Blocks    （BC&num;34 A&comma;B）</a>
					<div>
						Go to movies Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/65536 K (Java/Others) Tot ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3wRVob0.html" rel="bookmark" class="title">用&commat;ExceptionHandler 来进行异常处理</a>
					<div>
						有时候我们想统一处理一个Controller中抛出的异常怎么搞呢? 直接在Controller里面加上用@ExceptionHandler标注一个处理异常的方法像下面这样子 @ExceptionHan ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0Kql294.html" rel="bookmark" class="title">如何解酷派CPB包</a>
					<div>
						对酷派手机感兴趣(尤其刷机)的朋友可能会知道,酷派官方推出的升级包大部分是cpb压缩包.酷派的CPB格式文件包括BootLoader.NK.安装包几个部分,当然还可能包括一个叫GSMRaw的部分. 当 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MPWBeD4.html" rel="bookmark" class="title">（转）C&plus;&plus;著名类库</a>
					<div>
						1.C++各大有名库的介绍——C++标准库 2.C++各大有名库的介绍——准标准库Boost 3.C++各大有名库的介绍——GUI 4.C++各大有名库的介绍——网络通信 5.C++各大有名库的介绍— ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/47mj1D0.html" rel="bookmark" class="title">网页资源抓取</a>
					<div>
						// $text=file_get_contents('http://huaban.com/'); // preg_match_all('/&lt;img[^&gt;]*&gt;/i', $text, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0xvBWB4.html" rel="bookmark" class="title">Java部分总结图片版（已经加上原图链接下载！！！）</a>
					<div>
						Java基础知识图片版(原图下载链接)					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4pLa5K4.html" rel="bookmark" class="title">顺序查找算法</a>
					<div>
						//顺序查找法 #include &lt;iostream&gt; using namespace std; //第一种 int straipass(int *SqList,int key,int l ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3rBzzX3.html" rel="bookmark" class="title">&lbrack;六字真言&rsqb;2&period;嘛&period;异常定制和通用&period;md</a>
					<div>
						幻世当空 恩怨休怀 舍悟离迷 六尘不改 且怒且悲且狂哉! 最近一直在循环的一首歌! 丰富自己,比取悦他人更有力量.种下梧桐树,引得凤凰来.你若盛开,蝴蝶自来! 言归正传! 言归正传! 不要去大包大揽  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3rBpkb3.html" rel="bookmark" class="title">Swift学习】Swift编程之旅---属性（十四）</a>
					<div>
						属性关联特定类.结构或枚举的值,存储属性将存储常量和变量作为实例的一部分,计算属性用于计算一个值,而不进行存储.计算属性可以用于类.结构体和枚举里,存储属性只能用于类和结构体.存储属性和计算属性通常用 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MPJgRm3.html" rel="bookmark" class="title">从零开始学&lowbar;JavaScript&lowbar;系列（13）&mdash;&mdash;CSS&amp;lt&semi;2&amp;gt&semi;（新窗口打开，背景图片填充，底文字，小提示，CSS选择器整理）</a>
					<div>
						前注:图片和部分内容引用的网易云课堂的,所以,侵,私信,删. 这篇也算上周的 (10)打开一个网页时,以新窗口形式打开 将 &lt;a href=&quot;www.baidu.com&quot;&g ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0xXVQ70.html" rel="bookmark" class="title">游戏控制杆OUYA游戏开发快速入门教程</a>
					<div>
						游戏控制杆OUYA游戏开发快速入门教程 1.2.2  游戏控制杆 游戏控制杆各个角度的视图,如图1-4所示,它的硬件规格是本文选自OUYA游戏开发快速入门教程大学霸: 图1-4  游戏控制杆各个角度的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0jwL2e3.html" rel="bookmark" class="title">工作小脚本--发送公告</a>
					<div>
						from selenium import webdriverfrom time import sleep driver = webdriver.Firefox()driver.get(&quot;xx ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MowEgPM.html" rel="bookmark" class="title">CF GYM 100703L  Many questions</a>
					<div>
						题意:题意真坑……龙要问一系列问题,王子骑士公主分别以一个整数回答,如果王子和公主答案差的绝对值比骑士和公主答案差的绝对值小则说王子和公主的答案更相似,反过来如果前者比后者大则说骑士和公主的答案更相似 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/M6EGvX4.html" rel="bookmark" class="title">类实现多个接口的例子</a>
					<div>
						类实现多个接口 package java51; public interface Useleg { void run(); void walk(); } package java51; public  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3qkXwWM.html" rel="bookmark" class="title">关于拖移创建自定义的tableViewCell时引发的错误</a>
					<div>
						tableView大家都用的非常之多,一千一直使用代码创建所有的页面控制器  ,最近一直在学习熟悉使用storyboard ,于是又开始走上了手动拖动空间的方法来构造页面.今天遇到一个问题 ,为何我手 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0xmKjj3.html" rel="bookmark" class="title">洛谷&mdash;&mdash;P2149 &lbrack;SDOI2009&rsqb;Elaxia的路线</a>
					<div>
						P2149 [SDOI2009]Elaxia的路线 题目描述 最近,Elaxia和w的关系特别好,他们很想整天在一起,但是大学的学习太紧张了,他们 必须合理地安排两个人在一起的时间.Elaxia和w每 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3ZZ7oq3.html" rel="bookmark" class="title">机器学习算法需要注意的一些问题（二）</a>
					<div>
						训练样本大小选取的问题 模型学习的准确度与数据样本大小有关,那么如何展示更多的样本与更好的准确度之间的关系呢? 我们可以通过不断增加训练数据,直到模型准确度趋于稳定.这个过程能够很好让你了解,你的系统 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>专题</span>
		</div>
		<div class="box-content">
					</div>
	</div>

	<div class="box box-gallery3">
		<div class="box-heading">
			<span>随机推荐</span>
		</div>
		<div class="box-content clearfix">


		</div>
	</div>

</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 憋错料        | info#biecuoliao.com        | 10 q. 0.033 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <div style=" display: none ";>
  </div>


</body>
</html>
